/*result punch results from punch results command */
#include "cddefines.h"
#include "linesave.h"
#include "cddrive.h"
#include "taucon.h"
#include "mean.h"
#include "rdinit.h"
#include "readar.h"
#include "result.h"
#include "punresult.h"

void result(FILE* io)
{
	char chCard[81];
	int lgEOF;
	long int i , n;

#	ifdef DEBUG_FUN
	fputs( "<+>result()\n", debug_fp );
#	endif

	/* used to punch out line intensities, optical depths,
	 * and column densities */
	lgEOF = FALSE;
	/* first initialize the line image reader */
	rdinit();

	fprintf( io, "**********************************************************************************************************************************\n" );
	lgEOF = FALSE;
	readar(chCard,&lgEOF);
	while( !lgEOF )
	{
		fprintf( io, "%s\n", chCard );
		readar(chCard,&lgEOF);
	}

	/* first print any cautions or warnings */
	cdWarnings(io);
	cdCautions(io);
	fprintf( io, "**********************************************************************************************************************************\n" );

	fprintf( io, "C*OPTICAL DEPTHS ELECTRON=%10.3e\n", taucon.telec );

	fprintf( io, "BEGIN EMISSION LINES\n" );
	PunResult(io,"    ",0,0.,"Start");

	for( i=0; i < LineSave.nsum; i++ )
	{
		if( LineSv[i].sumlin > 0. )
		{
			PunResult(io,(char*)LineSv[i].chALab,LineSv[i].lin,
			  LineSv[i].sumlin,"Line ");
		}
	}

	PunResult(io,"    ",0,0.,"Flush");

	fprintf( io, "     \n" );

	fprintf( io, "BEGIN COLUMN DENSITIES\n" );
	/* make sure this is kept parallel with cdGett, which uses it
	 * real in all column densities*/

	/* this dumps out the whole array, which will be picked up by cdGett */
	/* following loop relies on LIMELM being 30, assert it here in case
	 * this is ever changed */
	assert( LIMELM == 30 );
	/* this order of indices is to keep 30 as the fastest variable,
	 * and the 32 (LIMELM+2) as the slower one */
	for(i=0; i < LIMELM+2; i++)
	{
		for( n=0; n<LIMELM; n++ )
		{
			fprintf( io, " %10.3e", IonMeans.xIonMeans[0][i][n] );
			/* throw line feed every 10 numbers */
			if( n==9|| n==19 || n==29 )
			{
				fprintf( io, "\n" );
			}
		}
	}

	fprintf( io, "END OF RESULTS\n" );
	fprintf( io, "**********************************************************************************************************************************\n" );

#	ifdef DEBUG_FUN
	fputs( " <->result()\n", debug_fp );
#	endif
	return;
}

